Singleton< T, F, instance > Class Template Reference

Restricts the instantiation of a class to one static object without locks. More...

## Public Member Functions

| Singleton (F objectFactory=F())
const T & | Ref (...) const
| Return a reference to the inner Singleton object. More...

## Detailed Description

### template<class T, class F = NewObject<T>, int instance = 0>
class Singleton< T, F, instance >

Restricts the instantiation of a class to one static object without locks.

Template Parameters

  T | the class or type
  F | the object factory for T
  instance | the initiali instance count

This class safely initializes a static object in a multithreaded environment. For C++03 and below it will do so without using locks for portability. If two threads call Ref() at the same time, they may get back different references, and one object may end up being memory leaked. This is by design. For C++11 and above, a standard double-checked locking pattern with thread fences are used. The locks and fences are standard and do not hinder portability.

See also
  Double-Checked Locking is Fixed In C++11

Definition at line 264 of file misc.h.

## Member Function Documentation

## Ref()

template<class T , class F , int instance>

const T & Singleton< T, F, instance >::Ref | ( |  | ... | ) | const

Return a reference to the inner Singleton object.

Ref() is used to create the object using the object factory. The object is only created once with the limitations discussed in the class documentation.

See also
  Double-Checked Locking is Fixed In C++11

Definition at line 308 of file misc.h.

The documentation for this class was generated from the following file:

- misc.h